Fix a bug in ChagePassword task
[snf-image] / snf-image-host / create
index acf8626..9fa084b 100755 (executable)
@@ -1,6 +1,6 @@
 #!/bin/bash
 
-# Copyright (C) 2011 GRNET S.A. 
+# Copyright (C) 2011 GRNET S.A.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,26 +24,99 @@ set -o pipefail
 
 ganeti_os_main
 
-if [ "$IMAGE_TYPE" = custom ]; then
-    image_file=/dev/null
-    image_size=\
-        $($CURL -sI "$IMAGE_NAME" | grep ^Content-Length: | cut -d" " -f2)
-else
-    image_file="$IMAGE_DIR/$IMAGE_NAME-$ARCH.$IMAGE_TYPE"
-    image_size="$(stat -L -c %s "$image_file")"
+if [ "$IMAGE_DEBUG" = "yes" ]; then
+    PS4='$(date "+%s.%N ($LINENO) + ")'
+    set -x
+elif [ "$IMAGE_DEBUG" != "no" ]; then
+    log_warning "Unsupported IMAGE_DEBUG value: \`$IMAGE_DEBUG'"
 fi
 
-if [ ! -e "$image_file" ]; then
-    log_error "Image file \`$image_file' does not exit."
-    exit 1
-fi
+monitor_pipe=$(mktemp -u)
+mkfifo -m 600 "$monitor_pipe"
+add_cleanup rm -f "$monitor_pipe"
 
-monitor="" #Empty if progress monitor support is disabled
-if [ "$progress_monitor_support" = "yes" ]; then
-    monitor="$PROGRESS_MONITOR \
-        -i $(printf "%q" "$INSTANCE_NAME") -r $image_size"
+if [ -n "$PROGRESS_MONITOR" ]; then
+    { sleep 1; $PROGRESS_MONITOR "$instance" < "$monitor_pipe" ; } &
+    monitor_pid="$!"
+else
+    sed -u 's|^|[MONITOR] |g' < "$monitor_pipe" &
+    monitor_pid="$!"
 fi
 
+# Create file descriptor to monitor_pipe
+exec {MONITOR_FD}>${monitor_pipe}
+add_cleanup  close_fd ${MONITOR_FD}
+
+# Ignore sigpipe signals. If progress monitor is dead and snf-image tries to
+# output something to the opened pipe, then a sigpipe will be raised. If we do
+# not catch this, the program will terminate.
+trap "" SIGPIPE
+
+trap report_and_cleanup EXIT
+
+echo "Processing image with ID: \`$IMG_ID' and type: \`$IMAGE_TYPE'" >&2
+
+case $BACKEND_TYPE in
+    local)
+        if [[ "$IMAGE_NAME" =~ ^local:// ]]; then
+            IMAGE_NAME="${IMAGE_NAME:8}"
+        elif [[ "$IMAGE_NAME" =~ ^file:// ]]; then
+            IMAGE_NAME="${IMAGE_NAME:7}"
+            log_warning "The file:// back-end identifier is deprecated and" \
+                        "will be removed in the future. Use local:// instead."
+        fi
+
+        canonical_image_dir="$(canonicalize "$IMAGE_DIR")"
+        if [ ! -d "$canonical_image_dir" ]; then
+            log_error "The IMAGE_DIR directory: \`$IMAGE_DIR' does not exist."
+            report_error "Unable to retrieve image file."
+        fi
+
+        image_file="$IMAGE_DIR/$IMAGE_NAME"
+        if [ ! -e "$image_file" ]; then
+            if [ -e "$image_file.$IMAGE_TYPE" ] ; then
+                image_file="$image_file.$IMAGE_TYPE"
+                log_warning "The \`.$IMAGE_TYPE' extension is missing from" \
+                    "the local back-end id. This id form is deprecated and" \
+                    " will be remove in the future."
+            else
+                log_error "Image file \`$image_file' does not exist."
+                report_error "Unable to retrieve image file."
+                exit 1
+            fi
+        fi
+
+        canonical_image_file="$(canonicalize "$image_file")"
+
+        if [[ "$canonical_image_file" != "$canonical_image_dir"* ]]; then
+            log_error "Image ID points to a file outside the image directory: \`$IMAGE_DIR'"
+            report_error "Invalid image ID"
+            exit 1
+        fi
+
+        image_size="$(stat -L -c %s "$image_file")"
+        ;;
+    null)
+        image_file=/dev/null
+        image_size=0
+        # Treat it as local file from now on...
+        BACKEND_TYPE="local"
+        ;;
+    network)
+        image_cmd="$CURL $(printf "%q" "$IMAGE_NAME")"
+        image_size=$($CURL -sI "$IMAGE_NAME" | grep ^Content-Length: | cut -d" " -f2)
+        ;;
+    pithos)
+        # For security reasons pass the database url to pithcat as an
+        # environmental variable.
+        export PITHCAT_INPUT_DB="$PITHOS_DB"
+        export PITHCAT_INPUT_DATA="$PITHOS_DATA"
+        cmd_args="$(printf "%q" "${IMAGE_NAME}")"
+        image_cmd="./pithcat $cmd_args"
+        image_size=$(./pithcat -s  $cmd_args)
+        ;;
+esac
+
 # If the target device is not a real block device we'll first losetup it.
 # This is needed for file disks.
 if [ ! -b "$blockdev" ]; then
@@ -69,71 +142,50 @@ case "$IMAGE_TYPE" in
             snf_export_PROPERTY_OSFAMILY="linux"
         fi
         ;;
-    diskdump|custom)
+    diskdump)
         target="$blockdev"
         ;;
+    *)
+        log_error "Unknown Image format: \`$IMAGE_TYPE'"
+        report_error "Unknown Image Format"
+        exit 1
+        ;;
 esac
 
-if [ "$IMAGE_TYPE" = "custom" ]; then
-    "$CURL" "$IMAGE_NAME" 2>/dev/null |\
-        $monitor dd bs=4M of="$target" oflag=direct
-else
+report_info "Starting image copy..."
+monitor="./copy-monitor.py -o $MONITOR_FD -r $image_size"
+if [ "$BACKEND_TYPE" = "local" ]; then
     # dd the dump to its new home :-)
     # Deploying an image file on a target block device is a streaming copy
     # operation. Enable the direct I/O flag on the output fd to avoid polluting
     # the host cache with useless data.
     $monitor dd bs=4M if="$image_file" of="$target" oflag=direct
+else
+    $image_cmd | $monitor dd bs=4M of="$target" oflag=direct
 fi
+report_info "Image copy finished."
 
 # Create a floppy image
 floppy=$(mktemp --tmpdir floppy.XXXXXX)
 add_cleanup rm "$floppy"
 
-snf_export_DEV=/dev/vda
 snf_export_TYPE="$IMG_FORMAT"
 snf_export_PASSWORD="$IMG_PASSWD"
 snf_export_HOSTNAME="$instance"
-snf_export_PROPERTIES="$IMG_PROPERTIES"
+if [ -n "$IMG_PROPERTIES" ]; then
+    snf_export_PROPERTIES="$IMG_PROPERTIES"
+fi
 if [ -n "$IMG_PERSONALITY" ]; then
     snf_export_PERSONALITY="$IMG_PERSONALITY"
 fi
 
-create_floppy "$floppy"
+snf_export_DEV=$(get_img_dev)
 
-# Invoke the helper vm to do the dirty job...
-result_file=$(mktemp --tmpdir result.XXXXXX)
-add_cleanup rm "$result_file"
-
-snapshot=$(mktemp --tmpdir helperXXXXXX.img)
-add_cleanup rm "$snapshot"
-
-"$QEMU_IMG" create -f qcow2 -b "$HELPER_IMG" "$snapshot"
-
-echo "$(date +%Y:%m:%d-%H:%M:%S.%N) Starting helper VM..."
-$TIMELIMIT -t "$HELPER_SOFT_TIMEOUT" -T "$HELPER_HARD_TIMEOUT" \
-    kvm -runas "$HELPER_USER" -drive file="$snapshot" \
-    -drive file="$blockdev",format=raw,if=virtio,cache=none \
-    -boot c -serial stdio -serial file:"$result_file" \
-    -fda "$floppy" -vga none -nographic -parallel none -monitor null \
-    -kernel "$HELPER_KERNEL" -initrd "$HELPER_INITRD" \
-    -append "quiet ro root=/dev/sda1 console=ttyS0,9600n8 snf_image_activate_helper" \
-    2>&1 | sed 's|^|HELPER: |g'
-echo "$(date +%Y:%m:%d-%H:%M:%S.%N) Helper VM finished."
-
-if [ $? -ne 0 ]; then
-    if [ $? -gt 128 ];  then
-        log_error "Helper was terminated. Did not finish on time."
-    fi
-    exit 1
-fi
+create_floppy "$floppy"
 
-# Read the first line. This will remove \r and \n chars
-result=$(sed 's|\r||g' "$result_file" | head -1)
+launch_helper "$blockdev" "$floppy"
 
-if [ "x$result" != "xSUCCESS" ]; then
-    log_error "Helper VM returned error"
-    exit 1
-fi
+report_info "Image customization finished successfully."
 
 # Execute cleanups
 cleanup